extern unsigned char *macaddress;
#define MACADDR ((unsigned char *)0x40f0016)

static void inline com1_out_char(char c)
{
	volatile unsigned short *SUPERIO = (volatile unsigned short *)0x7600000;

	while (!(SUPERIO[0x3FD] & 0x20)) ;
	SUPERIO[0x3F8] = c;
}

static void inline com1_puts(char *p)
{
	register char c;

	while ((c = *p++))
		com1_out_char(c);
}

static unsigned char inline hexdigit(unsigned char b)
{
	if (b < 10) return b + '0';
	else return b + 'A' - 10;
}

static void inline com1_puthex(char c)
{
	com1_out_char(hexdigit(c));
}

static void inline com1_puthex2(unsigned long c)
{
	com1_puthex((c>>12)&0xf);
	com1_puthex((c>>8)&0xf);
	com1_puthex((c>>4)&0xf);
	com1_puthex(c&0xf);
}

static void inline com1_puthex4(unsigned long c)
{
	com1_puthex2(c>>16);
	com1_puthex2(c);
}

void init_peripherals(void)
{
	register unsigned i;
	register volatile unsigned short *SUPERIO = (volatile unsigned short *)0x7600000;
	register volatile unsigned *EXTCONFIG = (volatile unsigned *)0x3ff3000;
	register volatile unsigned *GPIO = (volatile unsigned *)0x3ff5000;
	register volatile unsigned *TIMER = (volatile unsigned *)0x3ff6000;
	register volatile unsigned *INTC = (volatile unsigned *)0x3ff4000;
	register volatile unsigned *SYSCONFIG = (volatile unsigned *)0x3ff0000;

//	SYSCONFIG[0] &= (~6);
	SYSCONFIG[0] |= (6);
	TIMER[7] = 0x10000;

	INTC[0] = 0;
	INTC[2] = 0xffffff;
	INTC[1] = 0x7fffff;
	INTC[3] = 0x03020100;
	INTC[4] = 0x07060504;
	INTC[5] = 0x0B0A0908;
	INTC[6] = 0x0F0E0D0C;
	INTC[7] = 0x13121110;
	INTC[8] = 0x00161514;

	/* Initialize the access to the SMSC SuperIO chip */
	EXTCONFIG[4] &= (~0x300000);
	EXTCONFIG[4] |= 0x200000; /* set 16bit mode on DSX0 */

	EXTCONFIG[2] &= (~0x80001fff);
	EXTCONFIG[2] |= ( 0x80000fff);

	EXTCONFIG[3] |= 0x80000000;

/* This is probably a reset of the SuperIO chip? */
//	GPIO[3] = 0x3f75a;
//	GPIO[0] = 0x18c;
	GPIO[0] = 0xc;
	GPIO[3] = 0x8;
	GPIO[1] = 0;
	GPIO[2] = 0;
	for (i=0; i < 1000000; i++) ;
	GPIO[3] &= (~8);
	for (i=0; i < 1000000; i++) ;
	GPIO[3] |= 8;

/* Initialize the minimum Configuration Registers of the SuperIO chip */
	SUPERIO[0x370] = 0x55;

	SUPERIO[0x370] = 0x24; SUPERIO[0x371] = 0xfe;
	SUPERIO[0x370] = 0x25; SUPERIO[0x371] = 0xbe;
	SUPERIO[0x370] = 0x28; SUPERIO[0x371] = 0x34;

	SUPERIO[0x370] = 0xAA;

/* Initialize the UART of the SuperIO chip */
	SUPERIO[0x3FB] = 0x80; /* Access the divisor register */
	SUPERIO[0x3F8] = 1; SUPERIO[0x3F9] = 0; /* Set Baudrate to 115200 */
	SUPERIO[0x3FB] = 0x03; /* set 8N1 mode */
	SUPERIO[0x3FC] = 0x0B; /* set DTR, set RTS, set OUT2 */

	for (i = 0; i < 6; i++) {
		macaddress[3*i] = hexdigit(MACADDR[i]>>4);
		macaddress[3*i+1] = hexdigit(MACADDR[i]&0xf);
	}

	com1_puts("\r\n\r\nRunning Linux....\r\n");
	asm ("b 0x1001000");
}
