/* ld script for SMC7004ABRV2 router image */
OUTPUT_ARCH(arm)
ENTRY(_text)

SECTIONS
{
	. = 0x01000050;
	/DISCARD/ : {			/* Init code and data		*/
			*(.text.init)
			*(.proc.info)
			*(.arch.info)
			*(.taglist)
			*(.data.init)
			*(.setup.init)
			*(.initcall.init)
	}

	/DISCARD/ : {			/* Exit code and data		*/
		*(.text.exit)
		*(.data.exit)
		*(.exitcall.exit)
	}

	.text : {			/* Real text segment		*/
		_text = .;		/* Text and read-only data	*/
			init.o (.text)
			*(.text)
			*(.fixup)
			*(.gnu.warning)
			*(.text.lock)	/* out-of-line lock text */
			*(.rodata)
			*(.rodata.str1.4)
			*(.glue_7)
			*(.glue_7t)
			*(.kstrtab)
		. = ALIGN(16);
		__start___ex_table = .;	/* Exception table		*/
			*(__ex_table)
		__stop___ex_table = .;

		__start___ksymtab = .;	/* Kernel symbol table		*/
			*(__ksymtab)
		__stop___ksymtab = .;

		__start___kallsyms = .; /* All kernel symbols           */
			*(__kallsyms)
		__stop___kallsyms = .;

		*(.got)			/* Global offset table		*/

		_etext = .;		/* End of text section		*/
	}

	. = ALIGN(32);

	.data : {
        	__data_start = .;
		/*
		 * first, the init task union, aligned
		 * to an 8192 byte boundary.
		 */
		*(.init.task)

		/*
		 * then the cacheline aligned data
		 */
		. = ALIGN(32);
		*(.data.cacheline_aligned)

		/*
		 * and the usual data section
		 */
		*(.data)
		CONSTRUCTORS

		_edata = .;
	}

    . = ALIGN(0x10); 

	.bss : {
		__bss_start = .;	/* BSS				*/
		*(.bss)
		*(COMMON)
    . = ALIGN(0x10); 
    _ebss = . ;
	}


	. = 0x1000c00;

	.tags : {
		tags.o(*.linuxtags)
		_end = . ;
	}

	. = ALIGN(4);
	. = 0x1000ffc;

	.filler: : {
		LONG(0);
	}


					/* Stabs debugging sections.	*/
	.stab 0 : { *(.stab) }
	.stabstr 0 : { *(.stabstr) }
	.stab.excl 0 : { *(.stab.excl) }
	.stab.exclstr 0 : { *(.stab.exclstr) }
	.stab.index 0 : { *(.stab.index) }
	.stab.indexstr 0 : { *(.stab.indexstr) }
	.comment 0 : { *(.comment) }
	.debug_abbrev 0 : { *(.debug_abbrev) }
	.debug_info 0 : { *(.debug_info) }
	.debug_line 0 : { *(.debug_line) }
	.debug_pubnames 0 : { *(.debug_pubnames) }
	.debug_aranges 0 : { *(.debug_aranges) }
}
